<?php
/*
  $Id: qb_orders.php$
  
  Implemented by
  Atandra Systems
  www.atandra.com
  
  Copyright (c) 2006-2008 www.atandra.com
  Released under the GNU General Public License
*/
 // print("<html> asadsad");
  error_reporting(E_ALL & ~E_NOTICE);
   // print("here");

  DEFINE(__DEBUG, 0);
  DEFINE(__LANGUAGE_ID, 1);
  DEFINE(__DELIVERED_STATUS_ID, 3);
  DEFINE(__DELIVERED_STATUS_NAME, 'Delivered');
  
  DEFINE(__PROCESSING_STATUS_ID, 2);
  DEFINE(__PROCESSING_STATUS_NAME, 'Processing');
  
  DEFINE(__ENCODE_RESPONSE, true);
  DEFINE(__MAX_NUMBER_OF_OPTIONVALUES, 300);

  //header("Content-type: application/xml");
//  error_reporting(E_ALL);
  if (!isset($request)) {
    if (isset($_POST))
      $request = $_POST['request'];
    else
      $request = $HTTP_POST_VARS['request'];
  }  

  // Set the local configuration parameters - mainly for developers
  if (file_exists('includes/local/configure.php')) include('includes/local/configure.php');
  else
    // Include application configuration parameters
    require('includes/configure.php');

  $PHP_SELF = (isset($HTTP_SERVER_VARS['PHP_SELF']) ? $HTTP_SERVER_VARS['PHP_SELF'] : $HTTP_SERVER_VARS['SCRIPT_NAME']);
  DEFINE('LOCAL_EXE_GZIP',      '/usr/bin/gzip');
  DEFINE('LOCAL_EXE_GUNZIP',    '/usr/bin/gunzip');
  DEFINE('LOCAL_EXE_ZIP',       '/usr/local/bin/zip');
  DEFINE('LOCAL_EXE_UNZIP',     '/usr/local/bin/unzip');
  require(DIR_WS_FUNCTIONS .    'general.php');
  if (file_exists(DIR_WS_FUNCTIONS . 'password_funcs.php')) require(DIR_WS_FUNCTIONS . 'password_funcs.php');
  require(DIR_WS_INCLUDES . 'filenames.php');
  require(DIR_WS_INCLUDES . 'database_tables.php');
  require(DIR_WS_CLASSES .  'logger.php');
  require(DIR_WS_CLASSES .  'mime.php');
  require(DIR_WS_CLASSES .  'email.php');
  require(DIR_WS_FUNCTIONS . 'database.php');
  require(DIR_WS_FUNCTIONS . 'html_output.php');
  tep_db_connect() or die('Unable to connect to database server!');
  $configuration_query = tep_db_query('select configuration_key as cfgKey, configuration_value as cfgValue from ' . TABLE_CONFIGURATION);
  while ($configuration = tep_db_fetch_array($configuration_query)) DEFINE($configuration['cfgKey'], $configuration['cfgValue']);
  require(DIR_WS_CLASSES . 'object_info.php');
  require(DIR_WS_CLASSES . 'split_page_results.php');
  include(DIR_WS_CLASSES . 'language.php');
  $lng = new language(DEFAULT_LANGUAGE);
  $languages_id = $lng->language['id'];
  $language = $lng->language['directory'];
  //include(DIR_WS_LANGUAGES . $language.'.php');  
  //include(DIR_WS_LANGUAGES . $language . '/orders.php');  
  require('thubxml.php');
  
  //  *****************************************************
  //  AUTO INSTALLATION
  
//  if (!isTHUBInstalled()) 
//    if ($iresult = THUBInstall()) {
//      print(xmlErrorResponse('unknown', '9999', 'T-HUB Installation failed.('.$iresult.')', STORE_NAME, ''));
//      flush; exit;
//    };
  //  *****************************************************
  
  
  if (empty($request)) exit;

  // parse XML Request
  $request = trim(stripcslashes($request));
  
  // if (__DEBUG) _log($request, __line__);
  
  // print($request);
  $xmlRequest = new xml_doc($request);
  if (__DEBUG){
    ob_start();
    print("(xml parse error):");
  }
  
  $xmlRequest->parse();
  
  if (__DEBUG){
    _log(ob_get_contents(), __line__);
    @ob_end_clean();
  }
  
  $xmlRequest->getTag(0, $_tagName, $_tagAttributes, $_tagContents, $_tagTags);
  //$xmlRequest->getChildByName(0, "REQUEST")
  // print($_tagName);
  // print_r($_tagTags);
  
  if (strtoupper(trim($_tagName)) != 'REQUEST') {
    print(xmlErrorResponse('unknown', '9999', 'Unknown request', STORE_NAME, ''));flush;exit;
  }
  if (count($_tagTags) == 0) {
    print(xmlErrorResponse('unknown', '9999', 'REQUEST tag doesnt have necessry parameters', STORE_NAME, ''));flush;exit;
  }
  
  $RequestParams = Array();
  foreach ($_tagTags as $k=>$v){
    $xmlRequest->getTag($v, $tN, $tA, $tC, $tT);
    $RequestParams[strtoupper($tN)] = trim($tC);
  }
  
  if (!isset($RequestParams['COMMAND'])) {
    print(xmlErrorResponse('unknown', '9999', 'Command is not set', STORE_NAME, '')); exit;
  }
  $RequestParams['COMMAND'] = strtoupper($RequestParams['COMMAND']);
  
  // print($RequestParams['COMMAND']);
  if(
         ($RequestParams['COMMAND'] != ('GET'.'ORDERS')) 
      && ($RequestParams['COMMAND'] != ('UPDATE'.'ORDERS')) 
      && ($RequestParams['COMMAND'] != ('UPDATE'.'INVENTORY'))
      && ($RequestParams['COMMAND'] != ('UPDATE'.'ORDERS'.'SHIPPING'.'STATUS'))
      && ($RequestParams['COMMAND'] != ('UPDATE'.'ORDERS'.'PAYMENT'.'STATUS'))
    ) {
        print(xmlErrorResponse('unknown', '9999', 'Unknown Command'.$RequestParams['COMMAND'], STORE_NAME, ''));exit;
  }
  if (isset($RequestParams['REQUESTID'])) $request_id = $RequestParams['REQUESTID'];
  
  // check for installed admin auth contribution and do authentification.
  $sql_str = "SHOW TABLES LIKE 'admin'";    
  $orders_query = tep_db_query($sql_str);
  $rows = tep_db_fetch_array($orders_query);
  if ($rows) {
    $sql_str = "SHOW COLUMNS FROM admin LIKE 'admin_email_address'";
    $orders_query = tep_db_query($sql_str);
    $rows = tep_db_fetch_array($orders_query);
    if ($rows) {
      if (!isset($RequestParams['USERID']))     {print(xmlErrorResponse($RequestParams['COMMAND'], '9000', 'UserID field is not set', STORE_NAME, ''));exit;}
      if (!isset($RequestParams['PASSWORD']))   {print(xmlErrorResponse($RequestParams['COMMAND'], '9000', 'Password field is not set', STORE_NAME, ''));exit;}
      
      $sql_str = "SELECT admin_password FROM admin WHERE admin_email_address='".$RequestParams['USERID']."'";
      //$sql_str = "SELECT admin_password FROM admin WHERE admin_email_address='".$RequestParams['USERID']."' OR admin_username = '".$RequestParams['USERID']."'";
      $orders_query = tep_db_query($sql_str);
      $row = tep_db_fetch_array($orders_query);
      $is_authenticated = false;
      if($row){
        $is_authenticated = tep_validate_password($RequestParams['PASSWORD'], $row['admin_password']);
      }
      if (!$is_authenticated){
        print(xmlErrorResponse($RequestParams['COMMAND'], '9000', 'Order download service authentication failure - Login/Password supplied did not match', STORE_NAME, ''));
        exit;
      }
    }
  }
  
  
  // if (isset($RequestParams['SECURITYKEY'])) {
    // print(xmlErrorResponse($RequestParams['COMMAND'], '9999', 'Sequrity key is not supported in this version', STORE_NAME, ''));flush;exit;
  // }
  
  if (isset($RequestParams['LIMITORDERCOUNT']))
    define(QB_ORDERS_PER_RESPONSE, $RequestParams['LIMITORDERCOUNT']);
  else 
    define(QB_ORDERS_PER_RESPONSE, 25);

  if (isset($RequestParams['NUMBEROFDAYS']))
    define(QB_NUMBER_OF_DAYS, $RequestParams['NUMBEROFDAYS']);
  else 
    define(QB_NUMBER_OF_DAYS, 5);

  if (isset($RequestParams['ORDERSTARTNUMBER']))
    define(QB_ORDER_START_NUMBER, $RequestParams['ORDERSTARTNUMBER']);
  else 
    define(QB_ORDER_START_NUMBER, 0);
    
    
  if (isset($RequestParams['EXCLUDE-ORDERS'])) {
    $exclude_orders = trim($RequestParams['EXCLUDE-ORDERS']);
    if (empty($exclude_orders)) unset($exclude_orders);
  }

  if (isset($RequestParams['LANGUAGEID'])) {
    $language_id = trim($RequestParams['LANGUAGEID']);
    if (empty($language_id)) $language_id = __LANGUAGE_ID;
      
  } else {
    $language_id = __LANGUAGE_ID;
  }


  /* $xmlResponse = new xml_doc('<?xml version="1.0" encoding="UTF-8"?>'); */
  $xmlResponse = new xml_doc();
  $xmlResponse->version='1.0';
  $xmlResponse->encoding='ISO-8859-1';
  //$xmlResponse->encoding='UTF-8';
  
  $root = $xmlResponse->createTag("RESPONSE", array('Version'=>'4.0'));
  $envelope = $xmlResponse->createTag("Envelope", array(), '', $root);
  $xmlResponse->createTag("Command", array(), $RequestParams['COMMAND'], $envelope);

  switch ($RequestParams['COMMAND']){
  
    //***************************************************
    //
    //      get  Orders Service
    //
    //***************************************************  
    
    case 'GETORDERS' : {
			tep_db_query("set sql_big_selects=1");

		  if (isset($request_id)) $xmlResponse->createTag("RequestID", array(), $request_id, $envelope);
		  $xmlResponse->createTag("StoreID",   array(), STORE_NAME, $envelope, __ENCODE_RESPONSE);
		  $xmlResponse->createTag("StoreName", array(), STORE_NAME, $envelope, __ENCODE_RESPONSE);
    
//      $sql_str = "
//        SELECT 
//          COUNT(*) cnt 
//        FROM " . TABLE_ORDERS . " 
//        WHERE orders_id >".QB_ORDER_START_NUMBER."
//         AND to_days(Now()) - TO_DAYS(date_purchased) < ".QB_NUMBER_OF_DAYS."
//        ".(isset($exclude_orders)?" AND orders_id NOT IN ($exclude_orders) ":"")."
//        ".(QB_ORDERS_PER_RESPONSE>0?"LIMIT 0, ".QB_ORDERS_PER_RESPONSE:'');


		 	$str_date_filter = "";
		 	if (QB_ORDER_START_NUMBER == 0) {
		 		$str_date_filter = " AND to_days(Now()) - TO_DAYS(o.date_purchased) <= ".QB_NUMBER_OF_DAYS;
			}
     $sql_str = "
        SELECT 
          COUNT(*) cnt 
        FROM " . TABLE_ORDERS . " o
        WHERE orders_id >".QB_ORDER_START_NUMBER."
         ".$str_date_filter."
        ".(QB_ORDERS_PER_RESPONSE>0?"LIMIT 0, ".QB_ORDERS_PER_RESPONSE:'');


      // print($sql_str);
      $orders_query = tep_db_query($sql_str);
      $row = tep_db_fetch_array($orders_query);
      $no_orders = false;
      if ($row['cnt']==0) {
        $no_orders = true;
      }
    
      $xmlResponse->createTag("StatusCode", array(), $no_orders?"1000":"0", $envelope);
      $xmlResponse->createTag("StatusMessage", array(), $no_orders?"No Orders returned":"All Ok", $envelope);
      
      if ($no_orders){
        print($xmlResponse->generate()); flush; exit;
      }
      $ordersNode = $xmlResponse->createTag("Orders", array(), '', $root);

      // include(DIR_WS_CLASSES . 'order.php');
      
//      $orders_query_raw = "
//        SELECT 
//          o.*, 
//          osh.comments, 
//          SUM(ot.value) AS orders_total 
//        FROM ".TABLE_ORDERS." o 
//        LEFT JOIN ".TABLE_ORDERS_STATUS_HISTORY." osh ON o.orders_status = osh.orders_status_id AND o.orders_id = osh.orders_id 
//        LEFT JOIN ".TABLE_ORDERS_TOTAL." ot ON o.orders_id = ot.orders_id 
//        WHERE o.orders_id >".QB_ORDER_START_NUMBER."
//         AND to_days(Now()) - TO_DAYS(o.date_purchased) < ".QB_NUMBER_OF_DAYS."
//        ".(isset($exclude_orders)?" AND o.orders_id NOT IN ($exclude_orders) ":"")."
//        GROUP BY o.orders_id 
//        ORDER BY orders_id DESC, osh.orders_status_history_id DESC
//        ".(QB_ORDERS_PER_RESPONSE>0?" LIMIT 0, ".QB_ORDERS_PER_RESPONSE:'');
      
      $orders_query_raw = "
        SELECT 
          o.*, 
          osh.comments, 
          SUM(ot.value) AS orders_total 
        FROM ".TABLE_ORDERS." o 
        LEFT JOIN ".TABLE_ORDERS_STATUS_HISTORY." osh ON o.orders_status = osh.orders_status_id AND o.orders_id = osh.orders_id 
        LEFT JOIN ".TABLE_ORDERS_TOTAL." ot ON o.orders_id = ot.orders_id 
        WHERE o.orders_id >".QB_ORDER_START_NUMBER."
         ".$str_date_filter."
        GROUP BY o.orders_id 
        ORDER BY o.orders_id 
        ".(QB_ORDERS_PER_RESPONSE>0?" LIMIT 0, ".QB_ORDERS_PER_RESPONSE:'');
      
      
      // print($orders_query_raw);
    
      $orders_query = tep_db_query($orders_query_raw);
      while ($orders = tep_db_fetch_array($orders_query)) {
	  //print_r($orders);exit;
        $oInfo = new objectInfo($orders);
         //print_r($oInfo);
        $oInfo = parseSpecChars($oInfo);
        
        $orderNode  = $xmlResponse->createTag("Order",  array(), '', $ordersNode, __ENCODE_RESPONSE);
        $itemsNode  = $xmlResponse->createTag("Items",  array(), '', $orderNode, __ENCODE_RESPONSE);
        $billNode  = $xmlResponse->createTag("Bill",    array(), '', $orderNode, __ENCODE_RESPONSE);
        $shipNode  = $xmlResponse->createTag("Ship",    array(), '', $orderNode, __ENCODE_RESPONSE);
        $chargesNode  = $xmlResponse->createTag("Charges", array(), '', $orderNode, __ENCODE_RESPONSE);
          
        // Orders/Order info
        $xmlResponse->createTag("OrderID",  array(), $oInfo->orders_id,     $orderNode);
        $xmlResponse->createTag("Date",     array(), date("Y-m-d",strtotime($oInfo->date_purchased)), $orderNode); //date
        $xmlResponse->createTag("Time",     array(), date("H-i-s",strtotime($oInfo->date_purchased)), $orderNode); //time
        $xmlResponse->createTag("TimeZone", array(), 'PST',                 $orderNode, __ENCODE_RESPONSE);
        $xmlResponse->createTag("StoreId",  array(), STORE_NAME_ID,        $orderNode, __ENCODE_RESPONSE);
        $xmlResponse->createTag("StoreName",array(), STORE_NAME,           $orderNode, __ENCODE_RESPONSE);
        $xmlResponse->createTag("Currency", array(), $oInfo->currency,           $orderNode, __ENCODE_RESPONSE);
        if (!empty($oInfo->comments)) $xmlResponse->createTag("Comment",  array(), $oInfo->comments,      $orderNode, __ENCODE_RESPONSE);
          
        // Orders/Bill info
        $xmlResponse->createTag("PayMethod",array(), $oInfo->payment_method,   $billNode, __ENCODE_RESPONSE);
				
				if ($oInfo->orders_status == 1){
        	$xmlResponse->createTag("PayStatus",array(), "Pending",   $billNode);
        } else {
        	$xmlResponse->createTag("PayStatus",array(), "Cleared",   $billNode);
        }



        $xmlResponse->createTag("FirstName",array(), strtok($oInfo->billing_name, " "),   $billNode, __ENCODE_RESPONSE);
        //$xmlResponse->createTag("LastName", array(), strtok(" "),   $billNode, __ENCODE_RESPONSE);
				$xmlResponse->createTag("LastName", array(), strtok(" ")." ".strtok(" ")." ".strtok(" "),   $billNode, __ENCODE_RESPONSE);         
        
        $xmlResponse->createTag("CompanyName",array(), $oInfo->billing_company,   $billNode, __ENCODE_RESPONSE);
        
        $xmlResponse->createTag("Address1", array(), $oInfo->billing_street_address,   $billNode, __ENCODE_RESPONSE);
        $xmlResponse->createTag("Address2", array(), $oInfo->billing_suburb,   $billNode, __ENCODE_RESPONSE);
        $xmlResponse->createTag("City",     array(), $oInfo->billing_city,      $billNode, __ENCODE_RESPONSE);
        $xmlResponse->createTag("State",    array(), $oInfo->billing_state,     $billNode, __ENCODE_RESPONSE);
        $xmlResponse->createTag("Zip",      array(), $oInfo->billing_postcode,  $billNode, __ENCODE_RESPONSE);
        $xmlResponse->createTag("Country",  array(), $oInfo->billing_country,   $billNode, __ENCODE_RESPONSE);
        $xmlResponse->createTag("Email",    array(), $oInfo->customers_email_address,     $billNode, __ENCODE_RESPONSE);
        $xmlResponse->createTag("Phone",    array(), $oInfo->customers_telephone,     $billNode, __ENCODE_RESPONSE);

        $xmlResponse->createTag("PONumber",    array(), $oInfo->purchase_order_number,     $billNode, __ENCODE_RESPONSE);




        if (!empty($oInfo->cc_type) || (!empty($oInfo->cc_number))){
          $creditCard = $xmlResponse->createTag("CreditCard",  array(), '',   $billNode);
          
          // Orders/Bill/CreditCard info
          $xmlResponse->createTag("CreditCardType",     array(), $oInfo->cc_type,       $creditCard, __ENCODE_RESPONSE);
          $xmlResponse->createTag("CreditCardCharge",   array(), $oInfo->orders_total,  $creditCard, __ENCODE_RESPONSE);
          $xmlResponse->createTag("ExpirationDate",     array(), $oInfo->cc_expires,    $creditCard, __ENCODE_RESPONSE);
          $xmlResponse->createTag("CreditCardName",     array(), $oInfo->cc_owner,       $creditCard, __ENCODE_RESPONSE);
          $xmlResponse->createTag("CreditCardNumber",   array(), $oInfo->cc_number,     $creditCard, __ENCODE_RESPONSE);
        }
          

				//Gift wrapping
        $giftwrap_query = tep_db_query("SELECT title FROM " . TABLE_ORDERS_TOTAL . " WHERE orders_id = '".$oInfo->orders_id."' AND class = 'ot_giftwrapping'");
        $giftwrapping = tep_db_fetch_array($giftwrap_query);
        $giftwrap = ((substr($giftwrapping['title'], -1) == ':') ? substr(strip_tags($giftwrapping['title']), 0, -1) : strip_tags($giftwrapping['title']));
        $giftwrap = htmlspecialchars($giftwrap, ENT_NOQUOTES); 


        // Orders/Ship info
        $shipping_method_query = tep_db_query("SELECT title FROM " . TABLE_ORDERS_TOTAL . " WHERE orders_id = '".$oInfo->orders_id."' AND class = 'ot_shipping'");
        $shipping_method = tep_db_fetch_array($shipping_method_query);
        
        $ship_method = ((substr($shipping_method['title'], -1) == ':') ? substr(strip_tags($shipping_method['title']), 0, -1) : strip_tags($shipping_method['title']));
				$ship_method = preg_replace("/&\w+;/is", "", $ship_method);
        $ship_method = htmlspecialchars($ship_method, ENT_NOQUOTES); 

				$ship_method = preg_replace("/([^(]+)(\([^)]*?\))?\s*(\([^)]+\))/is", "$1$3", $ship_method);
        
        $xmlResponse->createTag("ShipMethod",array(), $ship_method,   $shipNode, __ENCODE_RESPONSE);
        //$xmlResponse->createTag("ShipMethod",array(), $ship_method,   $shipNode);
        $xmlResponse->createTag("FirstName",array(), strtok($oInfo->delivery_name, " "),   $shipNode, __ENCODE_RESPONSE);
        //$xmlResponse->createTag("LastName", array(), strtok(" "),   $shipNode, __ENCODE_RESPONSE);
				$xmlResponse->createTag("LastName", array(), strtok(" ")." ".strtok(" ")." ".strtok(" "),   $shipNode, __ENCODE_RESPONSE);         
        

        $xmlResponse->createTag("CompanyName",array(), $oInfo->delivery_company,   $shipNode, __ENCODE_RESPONSE);

        $xmlResponse->createTag("Address1", array(), $oInfo->delivery_street_address,   $shipNode, __ENCODE_RESPONSE);
        $xmlResponse->createTag("Address2", array(), $oInfo->delivery_suburb,   $shipNode, __ENCODE_RESPONSE);
        $xmlResponse->createTag("City",     array(), $oInfo->delivery_city,     $shipNode, __ENCODE_RESPONSE);
        $xmlResponse->createTag("State",    array(), $oInfo->delivery_state,    $shipNode, __ENCODE_RESPONSE);
        $xmlResponse->createTag("Zip",      array(), $oInfo->delivery_postcode, $shipNode, __ENCODE_RESPONSE);
        $xmlResponse->createTag("Country",  array(), $oInfo->delivery_country,  $shipNode, __ENCODE_RESPONSE);
        $xmlResponse->createTag("Email",    array(), $oInfo->customers_email_address,    $shipNode, __ENCODE_RESPONSE);
        $xmlResponse->createTag("Phone",    array(), $oInfo->customers_telephone,    $shipNode, __ENCODE_RESPONSE);



				//Associations
			  $sql_str_asc = "SHOW TABLES LIKE 'associations'";    
			  $asc_check_query = tep_db_query($sql_str_asc);
			  $asc_exist_rows = tep_db_fetch_array($asc_check_query);
			  if ($asc_exist_rows) {
					_log("associations table found", __line__);	

	        $asc_query_raw = "select a.asc_contact_name from associations a, associations_account_detail d  where a.asc_id = d.asc_id and d.asc_ord_id = ".$oInfo->orders_id;
	        $asc_query = tep_db_query($asc_query_raw);
					
					while ($asc = tep_db_fetch_array($asc_query)) {
							$ascInfo = new objectInfo($asc);
							$xmlResponse->createTag("SalesRep",  array(), $ascInfo->asc_contact_name,  $orderNode, __ENCODE_RESPONSE);
					}
				} else {
					_log("associations table not found", __line__);	
                    
			  }

        // get items of order
        // --------------------
        //$items_query_raw = "SELECT * FROM ".TABLE_ORDERS_PRODUCTS." WHERE orders_id = ".$oInfo->orders_id;
        //TABLE_PRODUCTS
				//SELECT o.* , p.products_weight FROM orders_products o, products p WHERE o.orders_id =1 AND o.products_id = p.products_id
				$items_query_raw = "SELECT o.* , p.products_weight FROM ".TABLE_ORDERS_PRODUCTS." o, ".TABLE_PRODUCTS." p WHERE o.orders_id =".$oInfo->orders_id ." AND o.products_id = p.products_id";


        
        $items_query = tep_db_query($items_query_raw);
        while ($items = tep_db_fetch_array($items_query)) {
          $iInfo = new objectInfo($items);
          $iInfo = parseSpecChars($iInfo);
          // print_r($iInfo);
          $itemNode = $xmlResponse->createTag("Item",    array(), '',    $itemsNode);
          $iInfo->products_model = trim($iInfo->products_model);
          $xmlResponse->createTag("ItemCode",       array(), empty($iInfo->products_model)?$iInfo->products_name:$iInfo->products_model, $itemNode, __ENCODE_RESPONSE);
          $xmlResponse->createTag("ItemDescription",array(), $iInfo->products_name,      $itemNode, __ENCODE_RESPONSE);
          $xmlResponse->createTag("Quantity",       array(), $iInfo->products_quantity,  $itemNode);
          $xmlResponse->createTag("UnitPrice",      array(), $iInfo->final_price,        $itemNode, __ENCODE_RESPONSE);
          $xmlResponse->createTag("ItemUnitWeight",      array(), $iInfo->products_weight,        $itemNode);
          
          //MJ - Fix for UK edition to handle VAT
          $xmlResponse->createTag("ItemTaxAmount",      array(), (($iInfo->products_tax * $iInfo->final_price * $iInfo->products_quantity)/100), $itemNode, __ENCODE_RESPONSE);
          
          
          $itemsa_query_raw = "SELECT * FROM ".TABLE_ORDERS_PRODUCTS_ATTRIBUTES." WHERE orders_id='".$oInfo->orders_id."' AND orders_products_id = '".$iInfo->orders_products_id."' order by  products_options";
          $itemsa_query = tep_db_query($itemsa_query_raw);
          
          while ($itemsa = tep_db_fetch_array($itemsa_query)) {
            $iaInfo = new objectInfo($itemsa);
            $iaInfo = parseSpecChars($iaInfo);
            // print_r($iaInfo);
            if (!isset($itemOptionsNode)) $itemOptionsNode  = $xmlResponse->createTag("ItemOptions",    array(), '',     $itemNode, __ENCODE_RESPONSE);
            //$xmlResponse->createTag("ItemOption", array('Name'=>$iInfo->products_options,'Value'=>$iInfo->products_options_values),'', $itemOptionsNode);
              $xmlResponse->createTag("ItemOption", array('Name'=> htmlspecialchars(strip_tags($iaInfo->products_options)),'Value'=>htmlspecialchars(strip_tags($iaInfo->products_options_values))),'',$itemOptionsNode, __ENCODE_RESPONSE);
          }
          unset($itemOptionsNode);
        } // end items
        
        
        $charges_query_raw = "
          SELECT 
            SUM(value) as value_sum,
            class as value_class
          FROM ".TABLE_ORDERS_TOTAL." 
          WHERE orders_id = ".$oInfo->orders_id."
          GROUP BY class";
        
        $charges_query = tep_db_query($charges_query_raw);
        $is_tax = false;
        $is_shipping = false;
        $is_total = false;
        
        //MJ - 072806
        $is_discount = false;
        //MJ - 072806
				
				

        //MJ - 072806
        //$xmlResponse->createTag("Discount", array(), "0",        $chargesNode);
        //MJ - 072806

        while ($charges = tep_db_fetch_array($charges_query)) {
          $chInfo = new objectInfo($charges);
          $chInfo = parseSpecChars($chInfo);

          if ($chInfo->value_class == "ot_tax") {
            $xmlResponse->createTag("Tax", array(), $chInfo->value_sum,      $chargesNode, __ENCODE_RESPONSE); 
            $is_tax = true;
          }
          if ($chInfo->value_class == "ot_shipping") {
            $xmlResponse->createTag("Shipping", array(), $chInfo->value_sum, $chargesNode, __ENCODE_RESPONSE);
            $is_shipping = true;
          }
          if ($chInfo->value_class == "ot_giftwrapping") {
            $xmlResponse->createTag("OtherCharge", array('Name'=>" $giftwrap "), $chInfo->value_sum, $chargesNode, __ENCODE_RESPONSE);
          }
          if ($chInfo->value_class=="ot_total") {
            $xmlResponse->createTag("Total", array(), $chInfo->value_sum,        $chargesNode, __ENCODE_RESPONSE);
            $is_total = true;
          }

	        //MJ - 072806
          if ($chInfo->value_class=="ot_coupon") {
            $xmlResponse->createTag("Discount", array(), $chInfo->value_sum,        $chargesNode, __ENCODE_RESPONSE);
            $is_discount = true;
          }
					//MJ




        }   
        if (!$is_tax)      $xmlResponse->createTag("Tax",      array(), "0",      $chargesNode, __ENCODE_RESPONSE); 
        if (!$is_shipping) $xmlResponse->createTag("Shipping", array(), "0",      $chargesNode, __ENCODE_RESPONSE); 
        if (!$is_total)    $xmlResponse->createTag("Total",    array(), "0",      $chargesNode, __ENCODE_RESPONSE); 
        //MJ - 072806
        if (!$is_discount)    $xmlResponse->createTag("Discount",    array(), "0",      $chargesNode, __ENCODE_RESPONSE); 
        //MJ - 072806
      } //orders
      // print("asdas");
      
    } break;  // end of get Orders Service


    //***************************************************
    //
    //      update Orders Service
    //
    //***************************************************  

    case 'UPDATEORDERS' : {
      $ordersTag = $xmlRequest->getChildByName(0, "ORDERS");
      $xmlRequest->getTag($ordersTag, $_tagName, $_tagAttributes, $_tagContents, $_tagTags);
      if (count($_tagTags) == 0) $no_orders = true; else $no_orders = false;
      $xmlResponse->createTag("StatusCode", array(), $no_orders?"1000":"0", $envelope);
      $xmlResponse->createTag("StatusMessage", array(), $no_orders?"No Orders returned":"All Ok", $envelope);
      if ($no_orders){
        print($xmlResponse->generate()); exit;
      }
      $ordersNode = $xmlResponse->createTag("Orders", array(), '', $root);
      foreach($_tagTags as $k=>$v){
        $xmlRequest->getTag($v, $_tagName, $_tagAttributes, $_tagContents, $_orderTags);
        $orderNode = $xmlResponse->createTag("Order",  array(), '',     $ordersNode);
        foreach($_orderTags as $k1=>$v1){
          $xmlRequest->getTag($v1, $_tagName, $_tagAttributes, $_tagContents, $_tempTags);
          $order[strtoupper($_tagName)] = $_tagContents;
          if (strtoupper($_tagName)!='LOCALSTATUS')
            $xmlResponse->createTag($_tagName,  array(), $_tagContents,     $orderNode);
        }
        $query = tep_db_query("SELECT count(*) cnt FROM ".TABLE_ORDERS." WHERE orders_id = '".$order['HOSTORDERID']."'");
        $row = tep_db_fetch_array($query);
        $result = 'Success';
        if ($row['cnt']==0) $result = 'Order not found';
        $updateQuery = "UPDATE " . TABLE_ORDERS . " SET last_modified = now() WHERE orders_id = '".$order['HOSTORDERID']."'";
        @tep_db_query($updateQuery);
        $xmlResponse->createTag('HostStatus',  array(), $result, $orderNode);
      }
    } break; // end of update Orders Service


    //***************************************************
    //
    //      update  Orders Shipping Status Service
    //
    //***************************************************
    
    case 'UPDATEORDERSSHIPPINGSTATUS' : {
      $ordersTag = $xmlRequest->getChildByName(0, "ORDERS");
      $xmlRequest->getTag($ordersTag, $_tagName, $_tagAttributes, $_tagContents, $_tagTags);
      if (count($_tagTags) == 0) $no_orders = true; else $no_orders = false;
      $xmlResponse->createTag("StatusCode", array(), $no_orders?"1000":"0", $envelope);
      $xmlResponse->createTag("StatusMessage", array(), $no_orders?"No Orders returned":"All Ok", $envelope);
      if ($no_orders){
        print($xmlResponse->generate()); exit;
      }
      $ordersNode = $xmlResponse->createTag("Orders", array(), '', $root);
      foreach($_tagTags as $k=>$v){
        $order = Array();
        $xmlRequest->getTag($v, $_tagName, $_tagAttributes, $_tagContents, $_orderTags);
        $orderNode = $xmlResponse->createTag("Order",  array(), '',     $ordersNode);
        foreach($_orderTags as $k1=>$v1){
          $xmlRequest->getTag($v1, $_tagName, $_tagAttributes, $_tagContents, $_tempTags);
          $order[strtoupper($_tagName)] = $_tagContents;
          if (strtoupper($_tagName)=='HOSTORDERID')
            $xmlResponse->createTag('HostOrderID',  array(), $_tagContents,     $orderNode);
          if (strtoupper($_tagName)=='LOCALORDERID')
            $xmlResponse->createTag('LocalOrderID',  array(), $_tagContents,     $orderNode);
        }

        $result = 'Failed';
        $check_status_query = tep_db_query("select customers_name, customers_email_address, orders_status, date_purchased from " . TABLE_ORDERS . " where orders_id = '" . $order['HOSTORDERID'] . "'");
        $check_status = tep_db_fetch_array($check_status_query);
        
        if ((tep_db_num_rows($check_status_query)!=0 )) {
          if (($check_status['orders_status'] != __DELIVERED_STATUS_ID)) {
            tep_db_query("update " . TABLE_ORDERS . " set orders_status = '" . __DELIVERED_STATUS_ID . "', last_modified = now() where orders_id = '" . $order['HOSTORDERID'] . "'");
            
            $customer_notified = '0';
            $comments = "\nOrder shipped on ".$order['SHIPPEDON']." via ".$order['SHIPPEDVIA']." using ".$order['SERVICEUSED']." service\n Tracking Number:".$order['TRACKINGNUMBER'];
            if ((strtoupper($order['NOTIFYCUSTOMER']) == 'YES') || ($order['NOTIFYCUSTOMER'] == '1')){
              $notify_comments = sprintf(EMAIL_TEXT_COMMENTS_UPDATE, $comments);
              $email = STORE_NAME . "\n" 
                . EMAIL_SEPARATOR . "\n" 
                . EMAIL_TEXT_ORDER_NUMBER . ' ' 
                . $order['HOSTORDERID'] . "\n" 
                . EMAIL_TEXT_INVOICE_URL . ' ' 
                . tep_catalog_href_link(FILENAME_CATALOG_ACCOUNT_HISTORY_INFO, 'order_id=' . $order['HOSTORDERID'], 'SSL') . "\n" 
                . EMAIL_TEXT_DATE_ORDERED . ' ' 
                . tep_date_long($check_status['date_purchased']) . "\n\n" 
                . $notify_comments . sprintf(EMAIL_TEXT_STATUS_UPDATE, __DELIVERED_STATUS_NAME);
                
              // tep_mail($check_status['customers_name'], $check_status['customers_email_address'], EMAIL_TEXT_SUBJECT, $email, STORE_OWNER, STORE_OWNER_EMAIL_ADDRESS);
              
              $customer_notified = '1';
            }
            tep_db_query("insert into " . TABLE_ORDERS_STATUS_HISTORY . " 
                (orders_id, orders_status_id, date_added, customer_notified, comments) values 
                ('" . $order['HOSTORDERID'] . "', '" . __DELIVERED_STATUS_ID . "', now(), '" . $customer_notified . "', '" . $comments  . "')");
            $result = 'Success';
          }
        }
        $xmlResponse->createTag('HostStatus',  array(), $result, $orderNode);
      }
      
      
    } break;  // end of update Orders Shipping Status Service
    
    
    //***************************************************
    //
    //      update  Orders Payment Status Service
    //
    //***************************************************
    
    case 'UPDATEORDERSPAYMENTSTATUS' : {
      $ordersTag = $xmlRequest->getChildByName(0, "ORDERS");
      $xmlRequest->getTag($ordersTag, $_tagName, $_tagAttributes, $_tagContents, $_tagTags);
      if (count($_tagTags) == 0) $no_orders = true; else $no_orders = false;
      $xmlResponse->createTag("StatusCode", array(), $no_orders?"1000":"0", $envelope);
      $xmlResponse->createTag("StatusMessage", array(), $no_orders?"No Orders returned":"All Ok", $envelope);
      if ($no_orders){
        print($xmlResponse->generate()); exit;
      }
      $ordersNode = $xmlResponse->createTag("CountOrders", array(), count($_tagTags), $root);
      
      $ordersNode = $xmlResponse->createTag("Orders", array(), '', $root);
      foreach($_tagTags as $k=>$v){
        $order = Array();
        $xmlRequest->getTag($v, $_tagName, $_tagAttributes, $_tagContents, $_orderTags);
        $orderNode = $xmlResponse->createTag("Order",  array(), '',     $ordersNode);
        foreach($_orderTags as $k1=>$v1){
          $xmlRequest->getTag($v1, $_tagName, $_tagAttributes, $_tagContents, $_tempTags);
          $order[strtoupper($_tagName)] = $_tagContents;
          if (strtoupper($_tagName)=='HOSTORDERID')
            $xmlResponse->createTag('HostOrderID',  array(), $_tagContents,     $orderNode);
          if (strtoupper($_tagName)=='LOCALORDERID')
            $xmlResponse->createTag('LocalOrderID',  array(), $_tagContents,     $orderNode);
        }
        
        $result = 'Failed';
        $check_status_query = tep_db_query("select customers_name, customers_email_address, orders_status, date_purchased from " . TABLE_ORDERS . " where orders_id = '" . $order['HOSTORDERID'] . "'");
        if (tep_db_num_rows($check_status_query)!=0 ) {
          $sqlstr = "update " . TABLE_ORDERS . " set orders_status = '" . __PROCESSING_STATUS_ID . "', last_modified = now() where orders_id = '" . $order['HOSTORDERID'] . "'";
          tep_db_query($sqlstr);
          if (strtoupper($order['PAYMENTSTATUS']) == 'CLEARED')
            $comments = "\nPayment cleared on ".$order['CLEAREDON'];
          else
            $comments = "\nPayment processed offline on ".date("m/d/Y");
            
          tep_db_query("insert into " . TABLE_ORDERS_STATUS_HISTORY . " 
              (orders_id, orders_status_id, date_added, customer_notified, comments) values 
              ('" . $order['HOSTORDERID'] . "', '" . __PROCESSING_STATUS_ID . "', now(), '0', '" . $comments  . "')");
          $result = 'Success';
        }
        $xmlResponse->createTag('HostStatus',  array(), $result, $orderNode);
      }
      
      
    } break;  // end of update Orders Payment Status Service
    
    //***************************************************
    //
    //      update Inventory Service
    //
    //***************************************************
    
    case 'UPDATEINVENTORY' : {
          
        $updDescrTag = $xmlRequest->getChildByName(0, "ADDPRODUCTS");
        $xmlRequest->getTag($updDescrTag, $_tagName, $_tagAttributes, $addProd, $_orderTags);

        $updDescrTag = $xmlRequest->getChildByName(0, "UPDATEDESCRIPTION");
        $xmlRequest->getTag($updDescrTag, $_tagName, $_tagAttributes, $updDescr, $_orderTags);
        
        $updPriceTag  = $xmlRequest->getChildByName(0, "UPDATEPRICE");
        $xmlRequest->getTag($updPriceTag, $_tagName, $_tagAttributes, $updPrice, $_orderTags);
        
        $updInvTag      = $xmlRequest->getChildByName(0, "UPDATEINVENTORY");
        $xmlRequest->getTag($updInvTag, $_tagName, $_tagAttributes, $updInv, $_orderTags);
        
        $InvListTag      = $xmlRequest->getChildByName(0, "INVENTORYLIST");
        $xmlRequest->getTag($InvListTag, $_tagName, $_tagAttributes, $InvList, $_orderTags);
        
        $InvListNumberTag = $xmlRequest->getChildByName(0, "INVENTORYLISTBATCHNUMBER");
        $xmlRequest->getTag($InvListNumberTag, $_tagName, $_tagAttributes, $InvListNumber, $_orderTags);
        
        $InvListSizeTag      = $xmlRequest->getChildByName(0, "INVENTORYLISTBATCHSIZE");
        $xmlRequest->getTag($InvListSizeTag, $_tagName, $_tagAttributes, $InvListSize, $_orderTags);
        
        $itemsTag = $xmlRequest->getChildByName(0, "ITEMS");
        $xmlRequest->getTag($itemsTag, $_tagName, $_tagAttributes, $_tagContents, $_tagTags);
        
        if (isset($request_id)) $xmlResponse->createTag("RequestID", array(), $request_id, $envelope);
        $xmlResponse->createTag("StoreID",   array(), STORE_NAME, $envelope, __ENCODE_RESPONSE);
        $xmlResponse->createTag("StoreName", array(), STORE_NAME, $envelope, __ENCODE_RESPONSE);
        
        $items = $xmlResponse->createTag("Items", array(), '', $root);

        $itemsCount = 0;
        $itemsProcessed = 0;
        
        
        $query = tep_db_query("SHOW COLUMNS FROM orders_products LIKE 'products_stock_attributes'"); 
        $rows = tep_db_fetch_array($query);
        if ($rows) {
          $QTPROInstalled = true;
        } else {
          $QTPROInstalled = false;
        }
        $xmlResponse->createTag("_QTPROInstalled", array(), $QTPROInstalled?"true":"false", $envelope);
        if ($addProd) {
            $itemsProcessed = 0;
            $itemsCount = 0;
            $_err_message_arr = Array();
            foreach($_tagTags as $k=>$itemTag) {   // look thruoght items
              $itemsCount++;
              $code = 0;

              // get item fields
              // ItemCodeParent
              $itemCodeTag = $xmlRequest->getChildByName($itemTag,          "ITEMCODE");           $xmlRequest->getTag($itemCodeTag,  $_tagName, $_tagAttributes, $itemCode, $_orderTags);
              $itemCodeTagParent = $xmlRequest->getChildByName($itemTag,    "ITEMCODEPARENT");     $xmlRequest->getTag($itemCodeTagParent,  $_tagName, $_tagAttributes, $itemCodeParent, $_orderTags);
              $itemPriceTag = $xmlRequest->getChildByName($itemTag,   "ITEMNAME");           $xmlRequest->getTag($itemPriceTag, $_tagName, $_tagAttributes, $itemName, $_orderTags);
              $itemDescrTag = $xmlRequest->getChildByName($itemTag,   "ITEMDESCRIPTION");    $xmlRequest->getTag($itemDescrTag, $_tagName, $_tagAttributes, $itemDescr, $_orderTags);
              $itemPriceTag = $xmlRequest->getChildByName($itemTag,   "PRICE");              $xmlRequest->getTag($itemPriceTag, $_tagName, $_tagAttributes, $itemPrice, $_orderTags);
              $itemStockTag = $xmlRequest->getChildByName($itemTag,   "QUANTITYINSTOCK");    $xmlRequest->getTag($itemStockTag, $_tagName, $_tagAttributes, $itemStock, $_orderTags);
              
              $itemStockTag = $xmlRequest->getChildByName($itemTag,   "MANUFACTURER");    $xmlRequest->getTag($itemStockTag, $_tagName, $_tagAttributes, $itemManufacturer, $_orderTags);
              $itemStockTag = $xmlRequest->getChildByName($itemTag,   "CATEGORY");    $xmlRequest->getTag($itemStockTag, $_tagName, $_tagAttributes, $itemCategory, $_orderTags);
              
              // parse options for certain product.
              $xmlRequest->getTag($itemTag, $_tagName, $_tagAttributes, $_tagContents, $_optionsTags);
              $opt_name_array = array();
              $opt_value_array = array();
              foreach($_optionsTags as $i=>$optionTag){
                $xmlRequest->getTag($optionTag, $_tagName, $_tagAttributes, $_tagContents, $sub_optionsTags);
                if($_tagName != "ITEMOPTION") continue;
                $opt_name_array[] = $_tagAttributes['NAME'];
                $opt_value_array[] = $_tagContents;
                // $xmlResponse->createTag ("__DEBUG", array(), 'tag_content:'.$_tagContents.", tag attr:".$_tagAttributes['NAME'], $envelope);
              }

              //
              // Manufacturer processing
              //
              $itemManufacturer = trim($itemManufacturer);
              //MJ 08042007
              $itemManufacturer = addslashes(trim($itemManufacturer));
              
              if ($itemManufacturer) {
                $query = tep_db_query("SELECT manufacturers_id FROM ".TABLE_MANUFACTURERS." WHERE manufacturers_name = '".$itemManufacturer."'");
                $row = tep_db_fetch_array($query);
                
                if($row) {    // does Manufacturer exist?
                  if ($row['manufacturers_id'])
                    $manufacturer_id = $row['manufacturers_id'];
                } else {
                  $res = tep_db_query("INSERT INTO " . TABLE_MANUFACTURERS . " (manufacturers_name) values ('$itemManufacturer')");
                  if (!$res){
                    $_err_message_arr[] = "Cannot execute INSERT NEW manufacturer. Manufacturer = $itemManufacturer";
                  } else {
                    $manufacturer_id = tep_db_insert_id();
                  }
                }
              } else {
                $manufacturer_id = 0;
              }
              //  -- end manufacturer processing
              
              
              //
              // Categories processing
              //
              $itemCategory = trim($itemCategory);
              $category_id = 0;
              if ($itemCategory) {
                $categories = explode("/", $itemCategory);
                $category_ids = Array();
                foreach ($categories as $category){
                	//MJ 08042007
              		$category = addslashes(trim($category));
                	
                  if ($category) {
                    $sqlstr = "
                        SELECT c.categories_id 
                        FROM ".TABLE_CATEGORIES." c 
                        INNER JOIN ".TABLE_CATEGORIES_DESCRIPTION." cd ON c.categories_id = cd.categories_id 
                        WHERE cd.categories_name = '".$category."'
                              AND cd.language_id = '".__LANGUAGE_ID."'
                              AND c.parent_id = '$category_id'";
                    $query = tep_db_query($sqlstr);
                    $row = tep_db_fetch_array($query);
                    
                    if($row) {    // does Category exist?
                      if ($row['categories_id'])
                        $category_id = $row['categories_id'];
                    } else {
                      $res = tep_db_query("INSERT INTO " . TABLE_CATEGORIES . " (parent_id, date_added, last_modified) values ('$category_id', now(), now())");
                      if (!$res){
                        $_err_message_arr[] = "Cannot execute INSERT NEW category. Category = $itemCategory";
                      } else {
                        $category_id = tep_db_insert_id();
                        $res = tep_db_query("INSERT INTO " . TABLE_CATEGORIES_DESCRIPTION . " (categories_id, language_id, categories_name) values ('$category_id', '".__LANGUAGE_ID."', '$category')");
                      }
                      
                    }
                    $category_ids[] = $category_id;
                  }
                } // categories loop
              }
              
              //  -- end categories processing
              
              $itemCode = trim($itemCode);
              $itemCodeParent = trim($itemCodeParent);

              $query = tep_db_query("SELECT products_id FROM ".TABLE_PRODUCTS." WHERE products_model = '".$itemCode."'");
              $row = tep_db_fetch_array($query);
              
              if($row && $itemCode) {    // does itemCode exist?
                if ($row['products_id']){
                  $product_id = $row['products_id'];
                  $products_model = $itemCode;
                }
              } else {
                $query = tep_db_query("SELECT products_id FROM ".TABLE_PRODUCTS." WHERE products_model = '".$itemCodeParent."'");
                $row = tep_db_fetch_array($query);
                if($row && $itemCodeParent) {  // does itemCodeParent exist and $itemCodeParent not empty?
                  if ($row['products_id']) {
                    $product_id = $row['products_id'];
                    $products_model = $itemCodeParent;
                  }
                } else {   // itemCode hasn't been found.  Product insert here.
                  $products_model = (count($opt_name_array)>0)?(!empty($itemCodeParent)?$itemCodeParent:$itemCode):$itemCode;
                  $res = tep_db_query("INSERT INTO " . TABLE_PRODUCTS . " 
                      (products_quantity, products_model, products_price, products_date_added, products_last_modified,  manufacturers_id, products_status, products_weight, products_tax_class_id) values 
                      ('$itemStock', '$products_model', '$itemPrice', now(), now(), '$manufacturer_id', 0,0, 1)");
                      
                  if (!$res){
                    $_err_message_arr[] = "Cannot execute INSERT NEW product. Item Code = $products_model";
                    $code = 1;
                  } else { // insert or assign options to new product
                    $product_id = tep_db_insert_id();
                    
	                	//MJ 08042007
	              		//'".addslashes($itemDescr)."'
                    $res = tep_db_query("INSERT INTO " . TABLE_PRODUCTS_DESCRIPTION . " 
                        (products_id, language_id, products_name, products_description) values 
                        ('$product_id', '".__LANGUAGE_ID."', '".addslashes($itemName)."', '".addslashes($itemDescr)."')");
                    $res = tep_db_query("INSERT INTO " . TABLE_PRODUCTS_TO_CATEGORIES . " 
                        (products_id, categories_id) values 
                        ('$product_id', '$category_id')");
                    
                  }
                
                } // end of else for ItemCodeParent
                
              }  // end of else for ItemCode
              
              $xmlResponse->createTag("_DEBUG", array(), $debug_str, $envelope);

              // insert options
              foreach ($opt_name_array as $i=>$opt_name){
                $opt_value = $opt_value_array[$i];
                
                // check if option name exists
                $query = tep_db_query("SELECT products_options_id FROM ".TABLE_PRODUCTS_OPTIONS." WHERE products_options_name = '".addslashes($opt_name)."' AND language_id='".__LANGUAGE_ID."'");
                $row = tep_db_fetch_array($query);
                if($row['products_options_id']) 
                  $opt_name_id = $row['products_options_id'];
                else {
                
                  $query = tep_db_query("SELECT MAX(products_options_id) as m FROM ".TABLE_PRODUCTS_OPTIONS);
                  $row = tep_db_fetch_array($query);
                  $products_options_id = $row['m']+1;
                  
                  $res = tep_db_query(
                    "INSERT INTO " . TABLE_PRODUCTS_OPTIONS . " 
                      (products_options_id, products_options_name, language_id".($QTPROInstalled?", products_options_track_stock":"").") 
                      VALUES 
                      ('$products_options_id', '".addslashes($opt_name)."', '".__LANGUAGE_ID."'".($QTPROInstalled?", '1'":"").")");
                  if (!$res) $_err_message_arr[] = "Cannot execute INSERT OPTION NAME for product. Option name = $opt_name";
                  else  $opt_name_id = $products_options_id;
                }
              
                // check if option value exists
                $query = tep_db_query("SELECT products_options_values_id FROM ".TABLE_PRODUCTS_OPTIONS_VALUES." WHERE products_options_values_name = '".addslashes($opt_value)."' AND language_id='".__LANGUAGE_ID."'");
                $row = tep_db_fetch_array($query);
                if($row['products_options_values_id']) 
                  $opt_value_id = $row['products_options_values_id'];
                else {
                  $query = tep_db_query("SELECT MAX(products_options_values_id) as m FROM ".TABLE_PRODUCTS_OPTIONS_VALUES);
                  $row = tep_db_fetch_array($query);
                  $products_options_values_id = $row['m']+1;
                  
                  $res = tep_db_query(
                    "INSERT INTO " . TABLE_PRODUCTS_OPTIONS_VALUES . " 
                      (products_options_values_id, products_options_values_name, language_id) 
                      VALUES 
                      ('$products_options_values_id', '".addslashes($opt_value)."', '".__LANGUAGE_ID."')");
                  if (!$res) $_err_message_arr[] = "Cannot execute INSERT OPTION VALUE for product. Option Value = $opt_value";
                  else  $opt_value_id = $products_options_values_id;
                }
                
                // check if option value is linked to option name
                $query = tep_db_query("SELECT COUNT(products_options_id) as cnt FROM ".TABLE_PRODUCTS_OPTIONS_VALUES_TO_PRODUCTS_OPTIONS." WHERE products_options_values_id = '$opt_value_id' AND products_options_id = '$opt_name_id'");
                $row = tep_db_fetch_array($query);
                if($row['cnt']==0) {
                  $res = tep_db_query(
                    "INSERT INTO " . TABLE_PRODUCTS_OPTIONS_VALUES_TO_PRODUCTS_OPTIONS . " 
                      (products_options_values_id, products_options_id) 
                      VALUES 
                      ('$opt_value_id', '$opt_name_id')");
                }
              
                // check if attribute with option name is linked to product  
                $query = tep_db_query("SELECT COUNT(products_id) as cnt FROM ".TABLE_PRODUCTS_ATTRIBUTES." WHERE options_values_id = '$opt_value_id' AND options_id = '$opt_name_id' AND products_id = '$product_id'");
                $row = tep_db_fetch_array($query);
                if($row['cnt']==0) {
                  $res = tep_db_query(
                    "INSERT INTO " . TABLE_PRODUCTS_ATTRIBUTES . " 
                      (products_id, options_values_id, options_id, options_values_price, price_prefix) 
                      VALUES 
                      ('$product_id', '$opt_value_id', '$opt_name_id',0,'+')");
                }
              
              }  // end of options loop 
              
              
              // Insert Category
              
              
              
              if ($code!=1) $itemsProcessed++;

              // creat xml output
              $item = $xmlResponse->createTag("Item", array(), '', $items);
              $xmlResponse->createTag("ItemCode", array(), $products_model, $item, __ENCODE_RESPONSE);
              $xmlResponse->createTag("ItemID", array(), $product_id, $item);
              $xmlResponse->createTag("InventoryUpdateStatus", array(), "$code", $item);
        
            }  // end items loop
          
          // $xmlResponse->createTag("_ERRORS", array(), join(" ", $_err_message_arr), $envelope, __ENCODE_RESPONSE);           
          
          
          
          
          
        


        } else {  // end of add product brunch

	        if( $InvList == 1){
	          if($InvListNumber == '0'){
	            $query = tep_db_query("UPDATE ".TABLE_PRODUCTS." SET InventoryBatch = 0 ");
	          } 
	
	            //      while ($orders = tep_db_fetch_array($orders_query)) {
	            //        $oInfo = new objectInfo($orders);
	            //        $oInfo = parseSpecChars($oInfo);
	            //				$xmlResponse->createTag("Comment",  array(), $oInfo->comments,      $orderNode);
	
	
	
	          $query = tep_db_query("SELECT * FROM ".TABLE_PRODUCTS_OPTIONS." WHERE language_id='".$language_id."'");
	          while ( $row = tep_db_fetch_array($query) ){
	            $optionsNames[$row['products_options_id']] = $row['products_options_name'];
	          }
	            
	          $query = tep_db_query("SELECT * FROM ".TABLE_PRODUCTS_OPTIONS_VALUES." WHERE language_id='$language_id'");
	          while ( $row = tep_db_fetch_array($query) ){
	            $optionsValues[$row['products_options_values_id']] = $row['products_options_values_name'];
	          }
	          
	          $idlist = array();
	          $qry = "SELECT products_id FROM ".TABLE_PRODUCTS." WHERE InventoryBatch = 0 LIMIT ".$InvListSize."";
	          $query = tep_db_query($qry);
	          while ( $row = tep_db_fetch_array($query) ){
	             $idlist[]  = $row['products_id'];
	          }
	          
	          if( count($idlist) ==0 ) { print(xmlErrorResponse('unknown', '9999', 'No items. '.$qry, STORE_NAME, '')); exit; }
	                    
	          $timer1 = new timerClass();
	          $timer1->start();
	                    
	          $qry = "SELECT d.products_name,  d.products_description, a.options_id, a.*, p.* FROM ".TABLE_PRODUCTS." p LEFT JOIN ".TABLE_PRODUCTS_DESCRIPTION." d ON d.products_id = p.products_id AND d.language_id='$language_id' LEFT JOIN ".TABLE_PRODUCTS_ATTRIBUTES." a ON a.products_id = p.products_id WHERE p.products_id IN (".join($idlist,',').")";
	          $query = tep_db_query($qry) or die(mysql_error());
	
	          if (__DEBUG) _log($timer1->end()." | ".$qry, __line__);
	          
	          while ( $row = tep_db_fetch_array($query) ){
	              if( isset($xmlitems[$row['products_id']] )){
	                  $xmlitems[$row['products_id']]['stock_options'][$row['options_id']][] = $row['options_id']."-".$row['options_values_id'];
	              } else { 
	                $xmlitems[$row['products_id']] = $row;
	                //if(isset($xmlitems[$row['options_id']]))    
	                $xmlitems[$row['products_id']]['stock_options'][$row['options_id']][] = $row['options_id']."-".$row['options_values_id'];
	              }
	          }
	          
	          $timer1->start();
	          
	          if(count($xmlitems) > 0){
	            foreach( $xmlitems as $product_id => $xmlitem){
	              if(!is_array($xmlitem['stock_options'])) {
	                $keys = array();
	              } else {
	                $keys = array_keys($xmlitem['stock_options']);
	              }
	              $o_index = array();
	              $o_max = array();
	              
	              $item = $xmlResponse->createTag("Item", array(), '', $items);
	              
	              for ( $l=0; $l<count($keys) ; $l++) {
	                $o_index[$l] = 0;
	                $o_max[$l] = count($xmlitem['stock_options'][$keys[$l]]);
	                if ($o_max[$l]==0) {
	                  $xmlResponse->createTag("ERROR", array(), "Prod Code:".$xmlitem['products_model']."  Prod ID: $product_id | Undefined option values", $envelope);
	                  $o_max[$l] = 1;
	                }
	              }
	              
	              //var_dump($xmlitem['products_description']);
	              
	              $xmlResponse->createTag("ItemCode", array(), $xmlitem['products_model'], $item, __ENCODE_RESPONSE);
	              $xmlResponse->createTag("ItemDescription", array(), htmlspecialchars(strip_tags($xmlitem['products_name'])), $item, __ENCODE_RESPONSE);
	              
	              
	              if(($xmlitem['options_id'] != null) && ($QTPROInstalled))  { // have options
	                while(true) {
	                  $quantityInWEB = -9999; 
	                  $res = '';
	                
	                  for( $row=0; $row<count($keys); $row++ ){
	                      if($res !='') $res=$res.',';
	                      $res = $res.$xmlitem['stock_options'][$keys[$row]][ $o_index[$row]];
	                      $o = split('-',$xmlitem['stock_options'][$keys[$row]][ $o_index[$row]]);
	                      $opt_id = trim($o[0]);  $opt_val_id = trim($o[1]);
	                     
	                      $xmlResponse->createTag("ItemOption", array("Name" => htmlspecialchars(strip_tags($optionsNames[$opt_id]))), htmlspecialchars(strip_tags($optionsValues[$opt_val_id])), $item, __ENCODE_RESPONSE);
	                  }
	                  
	                  $query_sel = "SELECT * FROM ".TABLE_PRODUCTS_STOCK." WHERE products_stock_attributes='".$res."' AND products_id = '".$product_id."'";
	                  $query_r = tep_db_query($query_sel);
	                  $stockrow = tep_db_fetch_array($query_r);
	                  if($stockrow) $quantityInWEB = $stockrow['products_stock_quantity'];
	                
	
	                  $xmlResponse->createTag("QuantityInStockWEB", array(), $quantityInWEB, $item);
	                  //echo $product_id." item<br>";
	                  if($xmlitem['options_id'] == null) { break;}
	                  if( ! updateIndex($o_index, $o_max) ) { break;}
	                } // while
	              } else { // no options
	                $quantityInWEB = $xmlitem['products_quantity']; 
	                $xmlResponse->createTag("QuantityInStockWEB", array(), $quantityInWEB, $item);
	              }
	            } // foreach
	          }  //count(xmlItems)
	          
	          if (__DEBUG) _log($timer1->end()." | xml items processing query above ", __line__);
	          
	          //die();
	          if(count($idlist) ==1 ) $_idlist = $idlist[0];
	          if(count($idlist) >1 ) $_idlist = join($idlist,",");
	          
	          $qry = "UPDATE ".TABLE_PRODUCTS." SET InventoryBatch='1' WHERE products_id IN (".$_idlist.")";
	          if(count($idlist) >0 )  $query = tep_db_query($qry);
	        
	        } else {  // if $InvList
	          // InvList == 0
	
	
	          // Go throught items
	          $itemsCount = 0;
	          $_err_message_arr = Array();
	          foreach($_tagTags as $k=>$itemTag){
	            $itemsCount++;
	            $code = 0;
	
	            // get item fields
	            $itemCodeTag = $xmlRequest->getChildByName($itemTag,    "ITEMCODE");           $xmlRequest->getTag($itemCodeTag,  $_tagName, $_tagAttributes, $itemCode, $_orderTags);
	            $itemCodeTagParent = $xmlRequest->getChildByName($itemTag,    "ITEMCODEPARENT");           $xmlRequest->getTag($itemCodeTagParent,  $_tagName, $_tagAttributes, $itemCodeParent, $_orderTags);
							//ItemCodeParent
							
	            $itemDescrTag = $xmlRequest->getChildByName($itemTag,   "ITEMDESCRIPTION");    $xmlRequest->getTag($itemDescrTag, $_tagName, $_tagAttributes, $itemDescr, $_orderTags);
	            $itemPriceTag = $xmlRequest->getChildByName($itemTag,   "PRICE");              $xmlRequest->getTag($itemPriceTag, $_tagName, $_tagAttributes, $itemPrice, $_orderTags);
	            $itemStockTag = $xmlRequest->getChildByName($itemTag,   "QUANTITYINSTOCK");    $xmlRequest->getTag($itemStockTag, $_tagName, $_tagAttributes, $itemStock, $_orderTags);
	            $itemStockWEBTag = $xmlRequest->getChildByName($itemTag,"QUANTITYINSTOCKWEB"); $xmlRequest->getTag($itemStockWEBTag, $_tagName, $_tagAttributes, $itemStockWEB, $_orderTags);
	            
	            // parse options
	            $xmlRequest->getTag($itemTag, $_tagName, $_tagAttributes, $_tagContents, $_optionsTags);
	            $opt_name_array = array();
	            $opt_value_array = array();
	            foreach($_optionsTags as $k=>$optionTag){
	              $xmlRequest->getTag($optionTag, $_tagName, $_tagAttributes, $_tagContents, $sub_optionsTags);
	              if($_tagName != "ITEMOPTION") continue;
	              $opt_name_array[] = $_tagAttributes['NAME'];
	              $opt_value_array[] = $_tagContents;
	              // $xmlResponse->createTag ("__DEBUG", array(), 'tag_content:'.$_tagContents.", tag attr:".$_tagAttributes['NAME'], $envelope);
	            }
	            $updateResult = true;
	            if ((count($opt_name_array)>0) && (count($opt_value_array)) && $QTPROInstalled){
	              $options = "'". join("','", $opt_name_array) ."'";
	              $values =  "'". join("','", $opt_value_array)."'";
	              
	              $query = tep_db_query("SELECT products_id FROM ".TABLE_PRODUCTS." WHERE products_model = '".$itemCode."'");
	              $row = tep_db_fetch_array($query);
	              if(!$row) {
	              	//MJ - 03/02/2007
	                //$updateResult=false;
	                //$_err_message_arr[] = "requested item '$itemCode' doesn't exist in product DB";
	              	
		              if($itemCodeParent <> ''){
			              $query = tep_db_query("SELECT products_id FROM ".TABLE_PRODUCTS." WHERE products_model = '".$itemCodeParent."'");
			              $row = tep_db_fetch_array($query);
		            		if(!$row) {
			                $updateResult=false;
			                $_err_message_arr[] = "requested item 'itemCodeParent' - '$itemCode' doesn't exist in product DB";
		            		}
		            	} else {
		                $updateResult=false;
		                $_err_message_arr[] = "requested item '$itemCode' doesn't exist in product DB";
		            	}
	              	
	              	
	              	//MJ - 03/02/2007
	              	
	              }
	              
	              //  does product exist?
	              if($updateResult){
	                $itemId = $row['products_id'];
	                $sql_str = "SELECT o.products_options_name , v.products_options_values_name, a.options_id, a.options_values_id 
	                  FROM ".TABLE_PRODUCTS_ATTRIBUTES." a 
	                  LEFT JOIN ".TABLE_PRODUCTS_OPTIONS." o ON a.options_id = o.products_options_id 
	                  LEFT JOIN ".TABLE_PRODUCTS_OPTIONS_VALUES." v ON v.products_options_values_id = a.options_values_id 
	                  WHERE v.language_id='$language_id'
	                    AND o.language_id='$language_id' 
	                    AND o.products_options_name in (".$options.") 
	                    AND  v.products_options_values_name in (".$values.") 
	                    AND a.products_id = '".$itemId."' 
	                  GROUP BY a.options_values_id, a.options_id 
	                  ORDER BY a.options_id";
	                _log("*** Select query for Product Option combination ***", __line__);  
	                $query = tep_db_query($sql_str);
	                  
	                $stock_attr = array();
	                while($row = tep_db_fetch_array($query)){
	                  if($row['options_values_id'] && $row['options_id'])
	                  $stock_attr[] = $row['options_id']."-".$row['options_values_id'];
	                }
	                
	                $attr_valid = true;
	                if( count($stock_attr) != count($opt_name_array) ){
	                  $updateResult=false;
	                  $_err_message_arr[] = "stock_attr != opt_name_array";
	                  $attr_valid = false;
	                } else {
	                  $stock_attr_full = join($stock_attr,',');
	                  $query_sel = "SELECT * FROM ".TABLE_PRODUCTS_STOCK." WHERE products_stock_attributes='".addslashes($stock_attr_full)."' AND products_id = '".addslashes($itemId)."'";
	                  $query_r = @tep_db_query($query_sel);
	                  if(!$query_r) {
	                    $updateResult=false;
	                    $_err_message_arr[] = "attributes not arrianged for match WEB DB of attributres";
	                  }
	                }
	              }
	              
	              // are atrributes and product item ok?
	              if($updateResult && $attr_valid){
	                $row = tep_db_fetch_array($query_r);
	                // if product with attributes doesn't exist in DB
	                if(!$row) {
	                  $query_ins = "INSERT INTO ".TABLE_PRODUCTS_STOCK." VALUES('','".addslashes($itemId)."','".addslashes($stock_attr_full)."','0')";
	                  _log($query_ins, __line__);
	                  $query_r = @tep_db_query($query_ins);
	                  if(!$query_r) {
	                    $updateResult=false;
	                    $_err_message_arr[] = "New products stock insertion failed";
	                  } else {
	                    $query_r = @tep_db_query($query_sel);
	                    if(!$query_r) {
	                      $_err_message_arr[] = "New products stock insertion ok, but verication failed(query issue)";
	                      $updateResult=false;
	                    } else {
	                      $row = tep_db_fetch_array($query_r);
	                      if(!$row) {
	                        $_err_message_arr[] = "New products stock insertion ok, but verication failed(no records returned)";
	                        $updateResult=false;
	                      }
	                    }
	                  }
	                }
	              } 
	              
	    
	              // if products stock was updated on previous step 
	              if($updateResult && $attr_valid){
	                $currentStockWEB = $row['products_stock_quantity'];
	                $stockId = $row['products_stock_id'];
	    
	                // if UPDATEINVENTORY == 1
	                if($updInv){
	                  //_log("update PRODUCTS_STOCK ID=$stockId", __line__);
	                  $query = @tep_db_query("UPDATE ".TABLE_PRODUCTS_STOCK." SET products_stock_quantity = '".addslashes($itemStock)."' WHERE products_stock_id = '".addslashes($stockId)."'");
	                  $currentStockWEB = $itemStock;
	                  if ( !$query ) $updateResult = false;
	                }
	              
	                if($updDescr) {
	                  //_log("update PRODUCTS_DESCRIPTION ID=$itemId", __line__);
	                    $query = @tep_db_query("UPDATE ".TABLE_PRODUCTS_DESCRIPTION." SET products_description='".addslashes($itemDescr)."' WHERE language_id='$language_id' AND products_id = '".addslashes($itemId)."'");
	                    if ( !$query ) $updateResult = false;
	                }
	                
	                if( $updPrice){
	                  //_log("update PRODUCTS ID=$itemId", __line__);
	                   $query = @tep_db_query("UPDATE ".TABLE_PRODUCTS." SET products_price='".addslashes($itemPrice)."' WHERE products_id = '".addslashes($itemId)."'");
	                   if ( !$query ) $updateResult = false;
	                }
	                if( $updateResult) $itemsProcessed++;
	              }  
	            
	            } else {  // updating product quantity only
	              // update product quantitty (products table)
	              if($updInv){
	              	//MJ 01/25/2006
	              	//Set default code = 1 which means product not found...
									$code=1;
	              	
	                $query = tep_db_query("SELECT products_id FROM ".TABLE_PRODUCTS." WHERE products_model = '".$itemCode."'");
	                //$row = tep_db_fetch_array($query);
	                //if($row) {
	                if (tep_db_num_rows($query) > 0)  {
	                  //_log("update PRODUCTS QUANTITY MODEL=$itemCode", __line__);
	
	                  //$qry = "UPDATE ".TABLE_PRODUCTS." SET products_quantity='$itemStock' WHERE products_model ='$itemCode'";
		                if( $updPrice){
		                  //_log("update PRODUCTS ID=$itemId", __line__);
	                  	$qry = "UPDATE ".TABLE_PRODUCTS." SET products_quantity='$itemStock', products_price='".addslashes($itemPrice)."' WHERE products_model ='$itemCode'";
		                } else {
	                  	$qry = "UPDATE ".TABLE_PRODUCTS." SET products_quantity='$itemStock' WHERE products_model ='$itemCode'";
		                }
	
	                  $query = tep_db_query($qry);
	                  //tep_db_num_rows
	                  
	                  if ($query){
	                    $currentStockWEB = $itemStock;
	                    $itemsProcessed++;
	                    $updateResult = true;
	                    $code = 0;  //product inventory was successfully updated
	                  } else {
	                    $_err_message_arr[] = "requested item '$itemCode' doesn't exist in product DB";
	                    $code = 1;  //product inventory was NOT successfully updated
	                  }
	                
	              }
	                
	                
	                
	                //}
	              }
	            }  
	              
	            $item = $xmlResponse->createTag("Item", array(), '', $items);
	            $xmlResponse->createTag("ItemCode", array(), $itemCode, $item);
	            for( $l =0; $l<count($opt_name_array); $l++){
	             // $xmlResponse->createTag("ItemOption", array("Name" => $opt_name_array[$l]), $opt_value_array[$l], $item);
	              $xmlResponse->createTag("ItemOption", array("Name" => htmlspecialchars(strip_tags($opt_name_array[$l]))), htmlspecialchars(strip_tags($opt_value_array[$l])), $item, __ENCODE_RESPONSE);
	            }
	            
	            if (!$updateResult && !$attr_valid) {
	            	$currentStockWEB = '-9999';
	            	$code = 1;  //inventory update failed for this item
	            }
	            $xmlResponse->createTag("QuantityInStockWEB", array(), $currentStockWEB, $item);
	            
	          	//MJ 01/25/2006
	            //if (!$attr_valid) $code = 2;
	            //$xmlResponse->createTag("InventoryUpdateStatus", array(), "$code", $item);
							//if ($updateResult) {
							//		$code = 0;
							//} else {
							//		$code = 1;
							//}
							$xmlResponse->createTag("InventoryUpdateStatus", array(), "$code", $item);
							//MJ - End of changes            
	            
	            // if (__DEBUG)
	              // $xmlResponse->createTag("__DEBUG", array(), join(";  ", $_err_message_arr), $item);
	            $_err_message_arr = Array();
	          }  // foreach
	        }  // else $InvList
        }
        if ( $itemsProcessed == $itemsCount ) {
          $code = "0";
          $message = "All Ok";
        } elseif( $itemsProcessed == 0 ){
        	//MJ 01/25/2006
          //$code = "9999";
          $code = "0";
					//MJ
          $message = "Warning: No items processed";
        } else {
        	//MJ 01/25/2006
          //$code = "9999";
          $code = "0";
					//MJ
          $message = "Warning: ".$itemsProcessed."/".$itemsCount." items processed";
        }
        
        $xmlResponse->createTag("StatusCode", array(), $code, $envelope);
        $xmlResponse->createTag("StatusMessage", array(), $message, $envelope);
    } break; // end of update Inventory Service
    
  } // end of command case

  header("Content-type: application/xml");
  print($xmlResponse->generate());

  // print_r($RequestParams);
  // print_r($xmlRequest);

function xmlErrorResponse($command, $code, $message, $provider, $request_id='') {
  header("Content-type: application/xml");
  $xmlResponse = new xml_doc('<?xml version="1.0" encoding="UTF-8"?>');
  //$xmlResponse = new xml_doc();
  //$xmlResponse->version='';
 // $xmlResponse->encoding='UTF-8';
  $root = $xmlResponse->createTag("RESPONSE", array('Version'=>'1.0'));
  //print("i'm here");
  $envelope = $xmlResponse->createTag("Envelope", array(), '', $root);
  $xmlResponse->createTag("Command", array(), $command, $envelope);
  $xmlResponse->createTag("StatusCode", array(), $code, $envelope);
  $xmlResponse->createTag("StatusMessage", array(), $message, $envelope);
  //if ($request_id) $xmlResponse->createTag("RequestID", array(), $request_id, $envelope);
  //$xmlResponse->createTag("Provider", array(), $provider, $envelope);
  return $xmlResponse->generate();
}

function parseTagName($str) {
  return preg_replace("/[-=+\s!@#\$\^\&%*\(\)\{\}\[\]':`~\.]/is", "", $str);
}

function parseSpecChars($obj) {
  foreach($obj as $k=>$v){
    $obj->$k = htmlspecialchars($v, ENT_NOQUOTES); 
  }
  return $obj;
}

function _log($text, $line) {

   //disabling log for production
   //$filename = "_log.txt";
   //$df =  fopen($filename, "a");
   //$str = date("m-d-Y | H:i:s ($line) ");
   //fwrite($df, $str.$text."\n");
   //fclose($df);
}

function updateIndex( & $index, $max) {
    $curr_index = count($index)-1;
    $limit_count = 0;
    while ( ( $index[$curr_index] +1 ) == $max[$curr_index] ){
        if($curr_index == 0) break;
        
        $index[$curr_index] = 0;
        $curr_index--;
        if ($curr_index<=0) break;
        if ($limit_count++ >= __MAX_NUMBER_OF_OPTIONVALUES) break;
    }
    $index[$curr_index]++;
    if (($curr_index==0) && ($max[0] ==$index[0])) return false;
    return true;
}

function isTHUBInstalled() {
  $result = false;
  $sql_str = "SHOW COLUMNS FROM orders LIKE 'thub_posted_to_accounting'";
  $orders_query = tep_db_query($sql_str);
  $rows = tep_db_fetch_array($orders_query);
  if ($rows) $result = true;
  return $result;
}

function THUBInstall(){
  $result3 = tep_db_query("ALTER TABLE `orders` 
  ADD `thub_posted_to_accounting` VARCHAR( 1 ) ,
  ADD `thub_posted_date` DATETIME,
  ADD `thub_accounting_ref` VARCHAR( 25 )");
  if ($result3) {
    //$result4 = tep_db_query("UPDATE `orders` set  thub_posted_to_accounting  = 'X', thub_accounting_ref = 'HISTORY'");
    $result4 = tep_db_query("UPDATE `orders` set  thub_posted_to_accounting  = 'X', thub_accounting_ref = 'HISTORY'  WHERE to_days(Now()) - TO_DAYS(date_purchased) > 5");
		

    if (!$result4) {
          return "Update of historical orders FAILED<br>";
    }
    
    $result31 = tep_db_query("ALTER TABLE `products` 
    ADD `InventoryBatch` int");
    if (!$result31) {
        return "ALTER of products table FAILED<br>";
    }
  } else {
    return "ALTER order table FAILED<br>";
  }
  return '';
}

//  dummy declaration for CRE loaded version.  This function is required for language files for declaration of constants of error messages 
function tep_session_save_path(){
  return;
}

class timerClass
{
	var $startTime;
	var $started;

	function timerClass($start=true) {
		$this->started = false;
		if ($start)
			$this->start();
	}

	function start() {
		$startMtime = explode(' ',microtime());
		$this->startTime = (double)($startMtime[0])+(double)($startMtime[1]);
		$this->started = true;
	}

	function end($iterations=1) {
		// get the time, check whether the timer was started later
		$endMtime = explode(' ',microtime());
		if ($this->started) {
			$endTime = (double)($endMtime[0])+(double)($endMtime[1]);
			$dur = $endTime - $this->startTime;
			$avg = 1000*$dur/$iterations;
			$avg = round(1000*$avg)/1000;
			return "$avg milliseconds";
		} else {
			return "timer not started";
		}
	}

}

?>

